#!/usr/bin/env python
import sys
import coral

from coral.addins.TEXTAGEN10.engine import *

if __name__ == "__main__":

    if (len(sys.argv) < 3) or (len(sys.argv) > 4):
        raise Exception("Invalid number of arguments")

    generator = sys.argv[1]
    target = sys.argv[2]
    outputdir = "tmp"
    
    if len(sys.argv) > 3:
        outputdir = sys.argv[3]

    result = generate_code(generator, target, outputdir)
    save_to_disc(result)


