from coral.modeler.extension import ContextMenuAction
import coral
import qt
from qt import *
from coral.modeler.coralmodeler import CoralModeler
from coral.modeler import modeler, iconcache
DI = coral.lang.XMIDI20
import coral.modeler.diagram.xmidi_diagrams as diagrams
from coral.modeler import extension
from coral.modeler.outline.outlineeditor import ElementPick

import engine as E
L = coral.lang.CONSTRAINT10

class Menu(ContextMenuAction):
    def createMenuItem(self,menu,lElement,lPresentation=[], diagram=None, position=None):

        self.diagram = diagram
        self.elements = lElement
        self.position = position
        self.menu=menu
        if lElement:
            self.element=lElement[0]
        else:
            self.element=None
            
        self.presentation=lPresentation
        self.constraintTab=None
        
        if self.element and (type(self.element) != coral.kernel.ProjectPtr):
          
      ##      if self.element.oclIsKindOf(coral.lang.CONSTRAINT10.ConstraintModel):
                
##                if E.isActive(self.element):
##                    menu.insertItem("Deactivate Checking",self.deActivateEngine)
##                else:
##                    menu.insertItem("Activate Checking",self.activateEngine)

            menu.insertItem("Constraint...", self.newConstraintModel)

  ##  def deActivateEngine(self):
##        E.deActivateCM(self.element)
        
##        allConstraintTabs = self.findConstraintTabs()
##        for ct in allConstraintTabs:
##            if ct.modelWidget and ct.modelWidget.cm == self.element:
##                ct.updateIcons(self.element)
##                ct.activateDeactivateButton.setIconSet(QIconSet(iconcache.getIcon("enable", "constraint")))
        
##    def activateEngine(self):
##        allConstraintTabs = self.findConstraintTabs()
##        for ct in allConstraintTabs:
##            if ct.modelWidget and ct.modelWidget.cm == self.element:
##                ct.setProgressPictureOn()
##                ct.progressLabel.repaint()
##        E.loadConstraintModel(self.element)
##        E.activateCM(self.element)
##        for ct in allConstraintTabs:
##            if ct.modelWidget and ct.modelWidget.cm == self.element:
##                ct.setProgressPictureOff()
##                ct.updateIcons(self.element)
##                ct.activateDeactivateButton.setIconSet(QIconSet(iconcache.getIcon("disable", "constraint")))
  

        
    def newConstraintModel(self):
        """Creates a new constraint model in the current project. If thera are no project selected it will
        create a new one."""
        # Gets the current focus from outline editor, so the user doesn't have to
        # click on some element just to set focus in the Constraint Tab
        if not self.element:
            return None


        project=self.element.__getRootsProject__()
        cPackage=ElementPick().pick(project.contents()[0], L.Package)

        if not cPackage:
            return
        
        coral.getTransactionManager().beginModifyCmd()
        try:
            cm = L.ConstraintModel(name="Constraint Evaluation")
            cm.constraint.append(cPackage)
            cm.target=self.element
            cm.__setProject__(project)
            self.editorSet.notifyFocusOn(cm)
        finally:
            coral.getTransactionManager().endModifyCmd()

                        

   
