# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.DIML10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache


class SelectionEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Selection")
        self.Label1= QLabel(self,"propertyLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("property:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.PropertyEdit=ReferenceLineEdit(self,"PropertyEdit")
        self.PropertyEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewProperty=QToolButton(self,"NewProperty")
        self.NewProperty.setGeometry(QRect(230,25,28,28))
        self.NewProperty.setPixmap(iconcache.getIcon("newAction"))
        self.NewProperty.setTextLabel("New Element")
        association = False
        for mc in [L.Selection]:
            if mc.getPropertyByName("property") and mc.getPropertyByName("property").isAssociation():
                association = True
                self.NewProperty.setHidden(True)
                noselect = True
                break
        self.SelectProperty=QToolButton(self,"SelectProperty")
        if noselect:
            self.SelectProperty.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectProperty.setGeometry(QRect(270,25,28,28))
        self.SelectProperty.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectProperty.setTextLabel("Select Element")
        self.Label2= QLabel(self,"typeLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("type:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TypeEdit=ReferenceLineEdit(self,"TypeEdit")
        self.TypeEdit.setGeometry(QRect(20,80,200,20))
        noselect = False
        self.NewType=QToolButton(self,"NewType")
        self.NewType.setGeometry(QRect(230,75,28,28))
        self.NewType.setPixmap(iconcache.getIcon("newAction"))
        self.NewType.setTextLabel("New Element")
        association = False
        for mc in [L.Selection]:
            if mc.getPropertyByName("type") and mc.getPropertyByName("type").isAssociation():
                association = True
                self.NewType.setHidden(True)
                noselect = True
                break
        self.SelectType=QToolButton(self,"SelectType")
        if noselect:
            self.SelectType.setGeometry(QRect(230,75,28,28))
        else:
            self.SelectType.setGeometry(QRect(270,75,28,28))
        self.SelectType.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectType.setTextLabel("Select Element")
        self.Label3= QLabel(self,"parameterTypeLabel")
        self.Label3.setGeometry(QRect(310,10,200,20))
        self.Label3.setText("parameterType:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ParameterPropertyEdit=ReferenceLineEdit(self,"ParameterPropertyEdit")
        self.ParameterPropertyEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewParameterProperty=QToolButton(self,"NewParameterProperty")
        self.NewParameterProperty.setGeometry(QRect(520,25,28,28))
        self.NewParameterProperty.setPixmap(iconcache.getIcon("newAction"))
        self.NewParameterProperty.setTextLabel("New Element")
        association = False
        for mc in [L.Selection]:
            if mc.getPropertyByName("parameterType") and mc.getPropertyByName("parameterType").isAssociation():
                association = True
                self.NewParameterProperty.setHidden(True)
                noselect = True
                break
        self.SelectParameterProperty=QToolButton(self,"SelectParameterProperty")
        if noselect:
            self.SelectParameterProperty.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectParameterProperty.setGeometry(QRect(560,25,28,28))
        self.SelectParameterProperty.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectParameterProperty.setTextLabel("Select Element")
        self.Label4= QLabel(self,"operationLabel")
        self.Label4.setGeometry(QRect(310,60,200,20))
        self.Label4.setText("operation:")
        self.OperationEdit=QComboBox(0,self,"OperationEdit")
        self.OperationEdit.setGeometry(QRect(310,80,200,20))
        self.Label5= QLabel(self,"parameterValueLabel")
        self.Label5.setGeometry(QRect(310,110,200,20))
        self.Label5.setText("parameterValue:")
        self.ParameterValueEdit=QLineEdit(self,"ParameterValueEdit")
        self.ParameterValueEdit.setGeometry(QRect(310,130,200,20))
        self.setName("Selection")
        self.PropertyEdit.setReadOnly(True)
        self.connect(self.NewProperty,SIGNAL('clicked()'),self.NewPropertyClicked)
        self.connect(self.SelectProperty,SIGNAL('clicked()'),self.SelectPropertyClicked)
        self.fieldTarget = None
        self.TypeEdit.setReadOnly(True)
        self.connect(self.NewType,SIGNAL('clicked()'),self.NewTypeClicked)
        self.connect(self.SelectType,SIGNAL('clicked()'),self.SelectTypeClicked)
        self.fieldTarget = None
        self.ParameterPropertyEdit.setReadOnly(True)
        self.connect(self.NewParameterProperty,SIGNAL('clicked()'),self.NewParameterPropertyClicked)
        self.connect(self.SelectParameterProperty,SIGNAL('clicked()'),self.SelectParameterPropertyClicked)
        self.fieldTarget = None
        self.connect(self.OperationEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.OperationEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.ParameterValueEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ParameterValueEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Selection]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.property
        self.fieldTarget=element.type
        self.fieldTarget=element.parameterType
        PropertyEditor.focusOn(self,element)
        self.PropertyEdit.setText("")
        if element.property:
            self.PropertyEdit.setText(getFQName(element.property,1))
            self.PropertyEdit.setEdited(0)
        
        self.TypeEdit.setText("")
        if element.type:
            self.TypeEdit.setText(getFQName(element.type,1))
            self.TypeEdit.setEdited(0)
        
        self.ParameterPropertyEdit.setText("")
        if element.parameterType:
            self.ParameterPropertyEdit.setText(getFQName(element.parameterType,1))
            self.ParameterPropertyEdit.setEdited(0)
        
        self.OperationEdit.clear()
        property = element.__type__().getPropertyByName("operation")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.OperationEdit.insertItem(ed.getDescription(i))
        self.OperationEdit.setCurrentItem(element.operation.__getEValue__())
        
        self.ParameterValueEdit.setText(unicode(element.parameterValue))
        self.ParameterValueEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            
            
            self.focus.operation=self.OperationEdit.currentItem()
            
            t=unicode(self.ParameterValueEdit.text())
            self.focus.parameterValue=t
            self.ParameterValueEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectPropertyClicked(self):
        ed=self.focus.__type__().getPropertyByName("property").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.property=r
            self.PropertyEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewPropertyClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("property")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectTypeClicked(self):
        ed=self.focus.__type__().getPropertyByName("type").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.type=r
            self.TypeEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTypeClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("type")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectParameterPropertyClicked(self):
        ed=self.focus.__type__().getPropertyByName("parameterType").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.parameterType=r
            self.ParameterPropertyEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewParameterPropertyClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("parameterType")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class GuardEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Guard")
        self.Label1= QLabel(self,"expressionLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("expression:")
        self.ExpressionEdit=QTextEdit(self,"ExpressionEdit")
        self.ExpressionEdit.setGeometry(QRect(40,30,300,200))
        self.setName("Guard")
        self.connect(self.ExpressionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ExpressionEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Guard]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        line,index=self.ExpressionEdit.getCursorPosition()
        self.ExpressionEdit.setText(unicode(element.expression))
        self.ExpressionEdit.setCursorPosition(line,index)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.ExpressionEdit.text())
            self.focus.expression=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ConnectorEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Connector")
        self.Label1= QLabel(self,"propertyLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("property:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.PropertyEdit=ReferenceLineEdit(self,"PropertyEdit")
        self.PropertyEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewProperty=QToolButton(self,"NewProperty")
        self.NewProperty.setGeometry(QRect(230,25,28,28))
        self.NewProperty.setPixmap(iconcache.getIcon("newAction"))
        self.NewProperty.setTextLabel("New Element")
        association = False
        for mc in [L.Connector]:
            if mc.getPropertyByName("property") and mc.getPropertyByName("property").isAssociation():
                association = True
                self.NewProperty.setHidden(True)
                noselect = True
                break
        self.SelectProperty=QToolButton(self,"SelectProperty")
        if noselect:
            self.SelectProperty.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectProperty.setGeometry(QRect(270,25,28,28))
        self.SelectProperty.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectProperty.setTextLabel("Select Element")
        self.Label2= QLabel(self,"nextPropertyLabel")
        self.Label2.setGeometry(QRect(310,10,200,20))
        self.Label2.setText("nextProperty:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.NextPropertyEdit=ReferenceLineEdit(self,"NextPropertyEdit")
        self.NextPropertyEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewNextProperty=QToolButton(self,"NewNextProperty")
        self.NewNextProperty.setGeometry(QRect(520,25,28,28))
        self.NewNextProperty.setPixmap(iconcache.getIcon("newAction"))
        self.NewNextProperty.setTextLabel("New Element")
        association = False
        for mc in [L.Connector]:
            if mc.getPropertyByName("nextProperty") and mc.getPropertyByName("nextProperty").isAssociation():
                association = True
                self.NewNextProperty.setHidden(True)
                noselect = True
                break
        self.SelectNextProperty=QToolButton(self,"SelectNextProperty")
        if noselect:
            self.SelectNextProperty.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectNextProperty.setGeometry(QRect(560,25,28,28))
        self.SelectNextProperty.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectNextProperty.setTextLabel("Select Element")
        self.setName("Connector")
        self.PropertyEdit.setReadOnly(True)
        self.connect(self.NewProperty,SIGNAL('clicked()'),self.NewPropertyClicked)
        self.connect(self.SelectProperty,SIGNAL('clicked()'),self.SelectPropertyClicked)
        self.fieldTarget = None
        self.NextPropertyEdit.setReadOnly(True)
        self.connect(self.NewNextProperty,SIGNAL('clicked()'),self.NewNextPropertyClicked)
        self.connect(self.SelectNextProperty,SIGNAL('clicked()'),self.SelectNextPropertyClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Connector]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.property
        self.fieldTarget=element.nextProperty
        PropertyEditor.focusOn(self,element)
        self.PropertyEdit.setText("")
        if element.property:
            self.PropertyEdit.setText(getFQName(element.property,1))
            self.PropertyEdit.setEdited(0)
        
        self.NextPropertyEdit.setText("")
        if element.nextProperty:
            self.NextPropertyEdit.setText(getFQName(element.nextProperty,1))
            self.NextPropertyEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectPropertyClicked(self):
        ed=self.focus.__type__().getPropertyByName("property").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.property=r
            self.PropertyEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewPropertyClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("property")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectNextPropertyClicked(self):
        ed=self.focus.__type__().getPropertyByName("nextProperty").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.nextProperty=r
            self.NextPropertyEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewNextPropertyClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("nextProperty")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class TypeInfoEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("TypeInfo")
        self.Label1= QLabel(self,"typeInfoLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("typeInfo:")
        self.TypeInfoEdit=QLineEdit(self,"TypeInfoEdit")
        self.TypeInfoEdit.setGeometry(QRect(40,30,200,20))
        self.setName("TypeInfo")
        self.connect(self.TypeInfoEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.TypeInfoEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.InitialPart]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.TypeInfoEdit.setText(unicode(element.typeInfo))
        self.TypeInfoEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.TypeInfoEdit.text())
            self.focus.typeInfo=t
            self.TypeInfoEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ProxyConnectorsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "ProxyConnectors"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.GraphNodePart]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [ConnectorEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "proxyConnector"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
                ed=self.focus.__type__().getPropertyByName("proxyConnector").getTarget()
                r=ElementPick().pick(self.focus, ed)
                if not r:
                    return
                coral.getTransactionManager().beginModifyCmd()
                try:
                    self.focus.proxyConnector.append(r)
                finally:
                    coral.getTransactionManager().endModifyCmd()
                return r
    elementFactory = staticmethod(elementFactory)


class ConnectorsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Connectors"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.GraphEdgePart]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [ConnectorEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "connector"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        return L.Connector()
    elementFactory = staticmethod(elementFactory)


class ContainedEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Contained")
        self.Label1= QLabel(self,"guardLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("guard:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.GuardEdit=ReferenceLineEdit(self,"GuardEdit")
        self.GuardEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewGuard=QToolButton(self,"NewGuard")
        self.NewGuard.setGeometry(QRect(230,25,28,28))
        self.NewGuard.setPixmap(iconcache.getIcon("newAction"))
        self.NewGuard.setTextLabel("New Element")
        self.SelectGuard=QToolButton(self,"SelectGuard")
        if noselect:
            self.SelectGuard.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectGuard.setGeometry(QRect(270,25,28,28))
        self.SelectGuard.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectGuard.setTextLabel("Select Element")
        self.Label2= QLabel(self,"selectionLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("selection:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.SelectionEdit=ReferenceLineEdit(self,"SelectionEdit")
        self.SelectionEdit.setGeometry(QRect(20,80,200,20))
        noselect = False
        self.NewSelection=QToolButton(self,"NewSelection")
        self.NewSelection.setGeometry(QRect(230,75,28,28))
        self.NewSelection.setPixmap(iconcache.getIcon("newAction"))
        self.NewSelection.setTextLabel("New Element")
        self.SelectSelection=QToolButton(self,"SelectSelection")
        if noselect:
            self.SelectSelection.setGeometry(QRect(230,75,28,28))
        else:
            self.SelectSelection.setGeometry(QRect(270,75,28,28))
        self.SelectSelection.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectSelection.setTextLabel("Select Element")
        self.Label3= QLabel(self,"parentLabel")
        self.Label3.setGeometry(QRect(310,10,200,20))
        self.Label3.setText("parent:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ParentEdit=ReferenceLineEdit(self,"ParentEdit")
        self.ParentEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewParent=QToolButton(self,"NewParent")
        self.NewParent.setGeometry(QRect(520,25,28,28))
        self.NewParent.setPixmap(iconcache.getIcon("newAction"))
        self.NewParent.setTextLabel("New Element")
        association = False
        for mc in [L.Contained]:
            if mc.getPropertyByName("parent") and mc.getPropertyByName("parent").isAssociation():
                association = True
                self.NewParent.setHidden(True)
                noselect = True
                break
        self.SelectParent=QToolButton(self,"SelectParent")
        if noselect:
            self.SelectParent.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectParent.setGeometry(QRect(560,25,28,28))
        self.SelectParent.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectParent.setTextLabel("Select Element")
        self.Label4= QLabel(self,"childLabel")
        self.Label4.setGeometry(QRect(310,60,200,20))
        self.Label4.setText("child:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ChildEdit=ReferenceLineEdit(self,"ChildEdit")
        self.ChildEdit.setGeometry(QRect(310,80,200,20))
        noselect = False
        self.NewChild=QToolButton(self,"NewChild")
        self.NewChild.setGeometry(QRect(520,75,28,28))
        self.NewChild.setPixmap(iconcache.getIcon("newAction"))
        self.NewChild.setTextLabel("New Element")
        association = False
        for mc in [L.Contained]:
            if mc.getPropertyByName("child") and mc.getPropertyByName("child").isAssociation():
                association = True
                self.NewChild.setHidden(True)
                noselect = True
                break
        self.SelectChild=QToolButton(self,"SelectChild")
        if noselect:
            self.SelectChild.setGeometry(QRect(520,75,28,28))
        else:
            self.SelectChild.setGeometry(QRect(560,75,28,28))
        self.SelectChild.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectChild.setTextLabel("Select Element")
        self.Label5= QLabel(self,"separatorLabel")
        self.Label5.setGeometry(QRect(310,110,200,20))
        self.Label5.setText("separator:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.SeparatorEdit=ReferenceLineEdit(self,"SeparatorEdit")
        self.SeparatorEdit.setGeometry(QRect(310,130,200,20))
        noselect = False
        self.NewSeparator=QToolButton(self,"NewSeparator")
        self.NewSeparator.setGeometry(QRect(520,125,28,28))
        self.NewSeparator.setPixmap(iconcache.getIcon("newAction"))
        self.NewSeparator.setTextLabel("New Element")
        association = False
        for mc in [L.Contained]:
            if mc.getPropertyByName("separator") and mc.getPropertyByName("separator").isAssociation():
                association = True
                self.NewSeparator.setHidden(True)
                noselect = True
                break
        self.SelectSeparator=QToolButton(self,"SelectSeparator")
        if noselect:
            self.SelectSeparator.setGeometry(QRect(520,125,28,28))
        else:
            self.SelectSeparator.setGeometry(QRect(560,125,28,28))
        self.SelectSeparator.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectSeparator.setTextLabel("Select Element")
        self.setName("Contained")
        self.GuardEdit.setReadOnly(True)
        self.connect(self.NewGuard,SIGNAL('clicked()'),self.NewGuardClicked)
        self.connect(self.SelectGuard,SIGNAL('clicked()'),self.SelectGuardClicked)
        self.fieldTarget = None
        self.SelectionEdit.setReadOnly(True)
        self.connect(self.NewSelection,SIGNAL('clicked()'),self.NewSelectionClicked)
        self.connect(self.SelectSelection,SIGNAL('clicked()'),self.SelectSelectionClicked)
        self.fieldTarget = None
        self.ParentEdit.setReadOnly(True)
        self.connect(self.NewParent,SIGNAL('clicked()'),self.NewParentClicked)
        self.connect(self.SelectParent,SIGNAL('clicked()'),self.SelectParentClicked)
        self.fieldTarget = None
        self.ChildEdit.setReadOnly(True)
        self.connect(self.NewChild,SIGNAL('clicked()'),self.NewChildClicked)
        self.connect(self.SelectChild,SIGNAL('clicked()'),self.SelectChildClicked)
        self.fieldTarget = None
        self.SeparatorEdit.setReadOnly(True)
        self.connect(self.NewSeparator,SIGNAL('clicked()'),self.NewSeparatorClicked)
        self.connect(self.SelectSeparator,SIGNAL('clicked()'),self.SelectSeparatorClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Contained]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.guard
        self.fieldTarget=element.selection
        self.fieldTarget=element.parent
        self.fieldTarget=element.child
        self.fieldTarget=element.separator
        PropertyEditor.focusOn(self,element)
        self.GuardEdit.setText("")
        if element.guard:
            self.GuardEdit.setText(getFQName(element.guard,1))
            self.GuardEdit.setEdited(0)
        
        self.SelectionEdit.setText("")
        if element.selection:
            self.SelectionEdit.setText(getFQName(element.selection,1))
            self.SelectionEdit.setEdited(0)
        
        self.ParentEdit.setText("")
        if element.parent:
            self.ParentEdit.setText(getFQName(element.parent,1))
            self.ParentEdit.setEdited(0)
        
        self.ChildEdit.setText("")
        if element.child:
            self.ChildEdit.setText(getFQName(element.child,1))
            self.ChildEdit.setEdited(0)
        
        self.SeparatorEdit.setText("")
        if element.separator:
            self.SeparatorEdit.setText(getFQName(element.separator,1))
            self.SeparatorEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            
            
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectGuardClicked(self):
        ed=self.focus.__type__().getPropertyByName("guard").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.guard=r
            self.GuardEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewGuardClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            o=L.Guard()
            self.focus.guard = o
            self.GuardEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectSelectionClicked(self):
        ed=self.focus.__type__().getPropertyByName("selection").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.selection=r
            self.SelectionEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewSelectionClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            o=L.Selection()
            self.focus.selection = o
            self.SelectionEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectParentClicked(self):
        ed=self.focus.__type__().getPropertyByName("parent").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.parent=r
            self.ParentEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewParentClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("parent")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectChildClicked(self):
        ed=self.focus.__type__().getPropertyByName("child").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.child=r
            self.ChildEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewChildClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("child")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectSeparatorClicked(self):
        ed=self.focus.__type__().getPropertyByName("separator").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.separator=r
            self.SeparatorEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewSeparatorClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("separator")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class ElementToXMIDIMappingEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ElementToXMIDIMapping")
        self.Label1= QLabel(self,"contextGuardLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("contextGuard:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ContextGuardEdit=ReferenceLineEdit(self,"ContextGuardEdit")
        self.ContextGuardEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewContextGuard=QToolButton(self,"NewContextGuard")
        self.NewContextGuard.setGeometry(QRect(230,25,28,28))
        self.NewContextGuard.setPixmap(iconcache.getIcon("newAction"))
        self.NewContextGuard.setTextLabel("New Element")
        self.SelectContextGuard=QToolButton(self,"SelectContextGuard")
        if noselect:
            self.SelectContextGuard.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectContextGuard.setGeometry(QRect(270,25,28,28))
        self.SelectContextGuard.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectContextGuard.setTextLabel("Select Element")
        self.Label2= QLabel(self,"acceptsConnectorsLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("acceptsConnectors:")
        self.AcceptsConnectorsEdit=QCheckBox(self,"AcceptsConnectorsEdit")
        self.AcceptsConnectorsEdit.setGeometry(QRect(20,80,200,20))
        self.AcceptsConnectorsEdit.setText("acceptsConnectors")
        self.Label3= QLabel(self,"isMinorElementLabel")
        self.Label3.setGeometry(QRect(310,10,200,20))
        self.Label3.setText("isMinorElement:")
        self.IsMinorElementEdit=QCheckBox(self,"IsMinorElementEdit")
        self.IsMinorElementEdit.setGeometry(QRect(310,30,200,20))
        self.IsMinorElementEdit.setText("isMinorElement")
        self.Label4= QLabel(self,"suitableDiagramsLabel")
        self.Label4.setGeometry(QRect(310,60,200,20))
        self.Label4.setText("suitableDiagrams:")
        self.SuitableDiagramsEdit=QTextEdit(self,"SuitableDiagramsEdit")
        self.SuitableDiagramsEdit.setGeometry(QRect(310,80,300,200))
        self.setName("ElementToXMIDIMapping")
        self.ContextGuardEdit.setReadOnly(True)
        self.connect(self.NewContextGuard,SIGNAL('clicked()'),self.NewContextGuardClicked)
        self.connect(self.SelectContextGuard,SIGNAL('clicked()'),self.SelectContextGuardClicked)
        self.fieldTarget = None
        self.connect(self.AcceptsConnectorsEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.AcceptsConnectorsEdit,SIGNAL('clicked()'),self.apply)
        self.connect(self.IsMinorElementEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.IsMinorElementEdit,SIGNAL('clicked()'),self.apply)
        self.connect(self.SuitableDiagramsEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.SuitableDiagramsEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.ElementToXMIDIMapping]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.contextGuard
        PropertyEditor.focusOn(self,element)
        self.ContextGuardEdit.setText("")
        if element.contextGuard:
            self.ContextGuardEdit.setText(getFQName(element.contextGuard,1))
            self.ContextGuardEdit.setEdited(0)
        
        self.AcceptsConnectorsEdit.setChecked(element.acceptsConnectors)
        
        self.IsMinorElementEdit.setChecked(element.isMinorElement)
        
        txt="\n".join([unicode(line) for line in element.suitableDiagrams]) 
        self.SuitableDiagramsEdit.setText(unicode(txt)+"\n")
        
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            self.focus.acceptsConnectors=self.AcceptsConnectorsEdit.isChecked()
            
            self.focus.isMinorElement=self.IsMinorElementEdit.isChecked()
            
            t=unicode(self.SuitableDiagramsEdit.text())
            self.focus.suitableDiagrams = []
            for s in t.split("\n"):
             if s == "":
              continue
             self.focus.suitableDiagrams.append(s)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectContextGuardClicked(self):
        ed=self.focus.__type__().getPropertyByName("contextGuard").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.contextGuard=r
            self.ContextGuardEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewContextGuardClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            o=L.Guard()
            self.focus.contextGuard = o
            self.ContextGuardEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class ChildrenEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Children"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.InitialPart]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [ContainedEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "children"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        return None
        
    elementFactory = staticmethod(elementFactory)


class DIPropertiesEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "DIProperties"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.InitialPart]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [DIPropertyEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "diProperty"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        return L.DIProperty()
    elementFactory = staticmethod(elementFactory)


class DIPropertyEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("DIProperty")
        self.Label1= QLabel(self,"keyLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("key:")
        self.KeyEdit=QLineEdit(self,"KeyEdit")
        self.KeyEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"valueLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("value:")
        self.ValueEdit=QLineEdit(self,"ValueEdit")
        self.ValueEdit.setGeometry(QRect(240,30,200,20))
        self.setName("DIProperty")
        self.connect(self.KeyEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.KeyEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ValueEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ValueEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.DIProperty]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.KeyEdit.setText(unicode(element.key))
        self.KeyEdit.setEdited(0)
        
        self.ValueEdit.setText(unicode(element.value))
        self.ValueEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.KeyEdit.text())
            self.focus.key=t
            self.KeyEdit.setEdited(0)
            
            t=unicode(self.ValueEdit.text())
            self.focus.value=t
            self.ValueEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

