import coral
from qt import *

class ElementTypeQListItem(QListViewItem):
    def __init__(self, element,*args):
        
        if hasattr(element, "name"):
            self.name = unicode(element.name)
        else:
            self.name = None

        self.element = element
        QListViewItem.__init__(self, *args)
        if self.name:
            self.setText(0,unicode(self.name))
        elif hasattr(element,"getName"):
            self.setText(0,self.element.getName())

        self.setText(1,unicode(self.element.__type__().getName()))
